import UserList
class TypeTest:
	def __init__(self,type):
		self.type=type
	def __call__(self,arg):
		if isinstance(arg,self.type):
			return 1
		else: return 0

class RestrictionError(Exception): pass

class RestrictedList(UserList.UserList):
	def __init__(self,testfn,init=[]):
		self.testfn=testfn
		self.testall(init)
		UserList.UserList.__init__(self,init)
	def test(self,x):
		if not self.testfn(x):
			raise RestrictionError(repr(x))
	def testall(self,L):
		for x in L: self.test(x)
		return
	def append(self,x): 
		self.test(x)
		UserList.UserList.append(self,x)
	def extend(self,L): 
		self.testall(L)
		UserList.UserList.extend(self,L)
	def insert(self,i,x): 
		self.test(x)
		UserList.UserList.insert(self,i,x)
	def __setitem__(self,i,x):  
		self.test(x)
		UserList.UserList.__setitem__(self,i,x)
	def __setslice__(self,i,j,L):  
		self.testall(L)
		UserList.UserList.__setslice__(self,i,j,L)
class TypeRestrictedList(RestrictedList):
	def __init__(self,type,init=[]):
		RestrictedList.__init__( \
			self,TypeTest(type),init)
