"""DictSet
Dictionary implementation of an abstract set"""
import AbstractSet
class DictSet(AbstractSet.AbstractSet):
	def __init__(self,elems=()):
		AbstractSet.AbstractSet.__init__(self)
		self.rep={}
		self.insertAll(elems)

	def contains(self,x): 
		return self.rep.has_key(x)

	def insert(self,x): 
		self.rep[x]=x
		return self

	def delete(self,x):
		if self.rep.has_key(x):
			del self.rep[x]
		return self

	def members(self):
		return self.rep.keys()

	def new(self):
		return DictSet()

	def copy(self):
		c=DictSet()
		c.rep=self.rep.copy()
		return c

	def size(self): 
		return len(self.rep)
	
